/*------------------------------------------------------------------------
  Junction: Concurrent data structures in C++
  Copyright (c) 2016 Jeff Preshing

  Distributed under the Simplified BSD License.
  Original location: https://github.com/preshing/junction

  This software is distributed WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the LICENSE file for more information.
------------------------------------------------------------------------*/

#ifndef JUNCTION_CORE_H
#define JUNCTION_CORE_H

//-----------------------------------------------
#include "junction_config.h" // junction_config.h generated by CMake.

// Default to true in case junction_config.h is missing entirely:
#ifndef JUNCTION_USE_STRIPING
#define JUNCTION_USE_STRIPING 1
#endif
//-----------------------------------------------

#include <turf/Core.h>
#include <turf/Assert.h>
#include <turf/Atomic.h>

namespace junction {
using namespace turf::intTypes;
}

// Enable this to force migration overflows (for test purposes):
#define JUNCTION_LEAPFROG_FORCE_MIGRATION_OVERFLOWS 0

#endif // JUNCTION_CORE_H
